<?php
namespace Teknisa\CADEST\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Response\Error;

class ProdfiliProdutoCtrlestq extends \Teknisa\CADEST\Controllers\TeknisaCrud {
    
    //protected $parameterBagColumns = ["TODOS", "P_CDPRODFIN", "P_CDPRODINI", "CDFILIAL", "IDCNTRESTOQ"];
    protected $dataSourceName = 'prodfili_produto_ctrlestq';
    protected $dataSourcePerfilAcess = 'filial_filioper_perfilacess';
    protected $dataSourceNameToSave = 'prodfili'; 
    protected $crudService;
	protected $dataSourceManager;
	protected $environment;
    protected $entityManager;

    public function __construct($crudService, ParameterBag $parameterBag, $dataSourceManager, $environment, $entityManager) {
		$this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
	}
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        parent::find($request, $response);
    }
    
    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            $rows = $request->getDataSet()->getRows();
            
            forEach($rows as $row){
                if($row['old_IDCNTRESTOQ'] != $row['IDCNTRESTOQ']           ||
                   $row['old_IDUTCTRLLOTE'] != $row['IDUTCTRLLOTE']){
    
                    $filial = $row['CDFILIAL'];
                    $cdarvprod = $row['CDARVPROD'];
                    
                    $conditions[] = array(
                        'columnName' => 'CDFILIAL',
                        'operator' => '=',
                        'value' => $filial,
                    );
                    $conditions[] = array(
                        'columnName' => 'CDARVPROD',
                        'operator' => '=',
                        'value' => $cdarvprod,
                    );
    
                    $dataSet = $this->crudService->getFilteredDataSet('validacao_prodemestoque', $conditions);
                    $rows = $dataSet->getRows();
                    if(count($rows) > 0){
                        throw new \Exception("Operação Bloqueada! Alteração requer que o produto seja zerado no estoque. É recomendado que antes de zerar o produto seja emitida a posição atual do mesmo na filial para posterior implantação.", 1);
                    }
                    
                    if($row['old_IDCNTRESTOQ'] != $row['IDCNTRESTOQ']){
                        if($row['IDUTCTRLLOTE'] != 'N')
                            throw new \Exception("Operação bloqueada! O produto realiza controle de lote. É recomendado que antes de alterar o controle de estoque, deve-se desmarcar o controle de  lote do produto.", 1);
                    }
                }
            }
            
            parent::save($request, $response);
         } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
         }
    }

}