<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class EsoPeriodico extends \Doctrine\ORM\EntityRepository {
    
    public function getEnviosEvento($nrorg, $nmevento, $nrestruturam, $nrtpambiente, $dtmescompetenc, $idativo = 'S', $nrchave = null, $nrtabela = null, $idoperacao = array(), $nrenvioexcl=null) {
        try{
            $esoPeriodico = Repositories::ESO_PERIODICO;
            $esoEvento = Repositories::ESO_EVENTO;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nmevento' => $nmevento,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => $nrtpambiente,
                'dtmescompetenc' => $dtmescompetenc,
                'idativo' => $idativo,
                'nrchave' => $nrchave,
                'nrtabela' => $nrtabela,
                'nrenvioexcl' => $nrenvioexcl,
            );
            $sql = "SELECT envio
                      FROM $esoPeriodico envio
                     WHERE envio.nrorg = :nrorg
                       AND envio.nmevento = :nmevento
                       AND (envio.nrestruturam = :nrestruturam OR (envio.nrestruturam <> :nrestruturam AND envio.nmevento IN ('S-2205','S-2206','S-2306'))) 
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.dtmescompetenc = :dtmescompetenc
                       AND envio.idativo = :idativo
                       AND (envio.nrchave = :nrchave OR :nrchave IS NULL)
                       AND (envio.nrtabela = :nrtabela OR :nrtabela IS NULL)
                       AND ((:nrenvioexcl = 'S' AND envio.nrenvioexcl IS NOT NULL) OR (:nrenvioexcl = 'N' AND envio.nrenvioexcl IS NULL) OR :nrenvioexcl IS NULL)";
            
            if (!empty($idoperacao)) {
                $sql .= " AND (envio.idoperacao IN ('".implode("','",$idoperacao)."'))";
            }
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}